unit XMLTransform;

interface

uses MSXML, SysUtils;

type
  TXMLTransform = class(TObject)
  public
    class function OpenXMLDocument(const FileName: string): IXMLDOMDocument;
    class function Transform(const xmldoc, stylesheet: IXMLDOMNode): string; overload;
    class function Transform(const xmldoc, stylesheet: TFileName): string; overload;
  end;

implementation

{ TXMLTransform }

class function TXMLTransform.OpenXMLDocument(const FileName: string): IXMLDOMDocument;
var
  Error: IXMLDOMParseError;
begin
  Result := CoDOMDocument.Create;

  if not Result.load(FileName) then
  begin
    Error := Result.parseError;
    raise Exception.CreateFmt('Parse error %x at %s:%d: %s',
      [Error.errorCode, FileName, Error.line, Error.reason]);
  end;
end;

class function TXMLTransform.Transform(const xmldoc, stylesheet: IXMLDOMNode): string;
begin
  Result := XMLDoc.transformNode(stylesheet);
end;

class function TXMLTransform.Transform(const xmldoc, stylesheet: TFileName): string;
begin
  Result := OpenXMLDocument(xmldoc).transformNode(OpenXMLDocument(stylesheet).documentElement);
end;

end.
